<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 5.10: Command-line Arguments</title>
<link href="sx8i.html" rev=precedes>
<link href="sx9.html" rel=precedes>
<link href="sx8.html" rev=subdocument>
</head>
<body>
<H2>section 5.10: Command-line Arguments</H2>

page 115
<p>The picture at the top of page 115 doesn't quite match the declaration
<pre>	char *argv[]
</pre>it's actually
a picture
of the situation declared by
<pre>	char **argv
</pre>which is what <TT>main</TT> actually receives.
(The array parameter declaration <TT>char *argv[]</TT>
is rewritten by the compiler to <TT>char **argv</TT>,
in accordance with the discussion in sections 5.3 and 5.8.)
Also, the ``0'' at the bottom of the array
is just a representation of the null pointer
which conventionally terminates the <TT>argv</TT> array.
(Normally, you'll never encounter
the terminating null pointer,
because if you think of <TT>argv</TT> as an array of size <TT>argc</TT>,
you'll never access beyond <TT>argv[argc-1]</TT>.)
</p><p>The loop
<pre>	for (i = 1; i &lt; argc; i++)
</pre>looks different from most loops we see in C
(which either start at 0 and use <TT>&lt;</TT>,
or start at 1 and use <TT>&lt;=</TT>).
The reason is that we're skipping <TT>argv[0]</TT>,
which contains the name of the program.
</p><p>The expression
<pre>	printf("%s%s", argv[i], (i &lt; argc-1) ? " " : "");
</pre>is a little nicety to print a space after each word
(to separate it from the next word)
but <em>not</em> after the last word.
(The nicety is just that
the code <em>doesn't</em> print an extra space at the end of the line.)
It would also be possible to fold in
the following <TT>printf</TT> of the newline:
<pre>	printf("%s%s", argv[i], (i &lt; argc-1) ? " " : "\n");
</pre></p><p>As I mentioned in comment on the bottom of page 109,
it's not necessary to write pointer-incrementing code like
<pre>	while(--argc &gt; 0)
		printf("%s%s", *++argv, (argc &gt; 1) ? " " : "");
</pre>if you don't feel comfortable with it.
I used to try write code like this,
because it
seemed to be
what everybody else did,
but it never sat well,
and it was always just a bit too hard to write
and to prove correct.
I've reverted to simple, obvious loops like
<pre>	int argi;
	char *sep = "";
<br>
<br>
	for (argi = 1; argi &lt; argc; argi++) {
		printf("%s%s", sep, argv[argi]);
		sep = " ";
	}
	printf("\n");
</pre>Often,
it's handy to have
the original <TT>argc</TT> and <TT>argv</TT> around later,
anyway.
(This loop also shows another way of handling space separators.)
</p><p>page 116
</p><p>Page 116 shows a simple improvement
on the matching-lines program first presented on page 69;
page 117 adds a few more improvements.
The differences between page 69 and page 116 are that
the pattern is read from the command line,
and <TT>strstr</TT> is used instead of <TT>strindex</TT>.
The difference between page 116 and page 117
is the handling of the <TT>-n</TT> and <TT>-x</TT> options.
(The next obvious improvement,
which we're not quite in a position to make yet,
is to allow a file name to be specified on the command line,
rather than always reading from the standard input.)
</p><p>page 117
</p><p>Several aspects of this code deserve note.
</p><p>The line
<pre>	while (c = *++argv[0])
</pre>is <em>not</em> in error.
(In isolation,
it might look like an example of the classic error of
accidentally writing <TT>=</TT> instead of <TT>==</TT> in a comparison.)
What it's actually doing is another version of a combined set-and-test:
it assigns the next character pointed to by <TT>argv[0]</TT> to 
<TT>c</TT>, and compares it against <TT>'\0'</TT>.
You can't see the comparison against <TT>'\0'</TT>,
because it's implicit
in the usual interpretation of a nonzero expression
as ``true.''
An explicit test would look like this:
<pre>	while ((c = *++argv[0]) != '\0')
</pre><TT>argv[0]</TT> is a pointer to a character in a string;
<TT>++argv[0]</TT> increments that pointer
to point to the next character in the string;
and <TT>*++argv[0]</TT> increments the pointer
while returning the next character pointed to.
<TT>argv[0]</TT> is not the first string on the command line,
but rather whichever one we're looking at now,
since elsewhere in the loop we increment <TT>argv</TT> itself.
</p><p>Some of the extra complexity in this loop is to make sure that 
it can handle both
<pre>	-x -n
</pre>and
<pre>	-xn
</pre>In pseudocode,
the option-parsing loop is
<pre>	for ( <I>each word on the command line</I> )
		if ( <I>it begins with</I> '-' )
			for ( <I>each character</I> c <I>in that word</I> )
				switch ( c )
					...
</pre>For comparison,
here is another way of writing effectively the same loop:
<pre>	int argi;
	char *p;
<br>
<br>
	for (argi = 1; argi &lt; argc &amp;&amp; argv[argi][0] == '-'; argi++)
		for (p = &amp;argv[argi][1]; *p != '\0'; p++)
			switch (*p) {
			case 'x':
				...
</pre>This uses array notation to access the words on the command line,
but pointer notation to access the characters within a word
(more specifically, a word that begins with <TT>'-'</TT>).
We could also use array notation for both:
<pre>	int argi, chari;
<br>
<br>
	for (argi = 1; argi &lt; argc &amp;&amp; argv[argi][0] == '-'; argi++)
		for (chari = 1; argv[argi][chari] != '\0'; chari++)
			switch (argv[argi][chari]) {
			case 'x':
				...
</pre>In either case,
the inner, character loop
starts at the second character
(index <TT>[1]</TT>),
not the first,
because the first character
(index <TT>[0]</TT>)
is the <TT>'-'</TT>.
</p><p>It's easy to see how the <TT>-n</TT> option is implemented.
If <TT>-n</TT> is seen, the <TT>number</TT> flag is set to 1
(a.k.a. ``true''),
and later,
in the line-matching loop,
each time a line is printed,
if the <TT>number</TT> flag is true,
the line number is printed first.
It's harder to see how <TT>-x</TT> works.
An <TT>except</TT> flag is set to 1 if <TT>-x</TT> is present,
but how is <TT>except</TT> used?
It's buried down there in the line
<pre>	if ((strstr(line, *argv) != NULL) != except)
</pre>What does that mean?
The subexpression
<pre>	(strstr(line, *argv) != NULL)
</pre>is 1 if the line contains the pattern,
and 0 if it does not.
<TT>except</TT> is 0 if we should print matching lines,
and 1 if we should print non-matching lines.
What we've actually implemented here is an ``exclusive OR,''
which is ``if A or B but <em>not</em> both.''
Other ways of writing this would be
<pre>	int matched = (strstr(line, *argv) != NULL);
	if (matched &amp;&amp; !except || !matched &amp;&amp; except) {
		if (number)
			printf("%ld:", lineno);
		printf("%s", line);
		found++;
	}
</pre>or
<pre>	int matched = (strstr(line, *argv) != NULL);
	if (except ? !matched : matched) {
		if (number)
			printf("%ld:", lineno);
		printf("%s", line);
		found++;
	}
</pre>or
<pre>	int matched = (strstr(line, *argv) != NULL);
	if (!except) {
		if (matched) {
			if (number)
				printf("%ld:", lineno);
			printf("%s", line);
			found++;
		}
	}
	else {
		if (!matched) {
			if (number)
				printf("%ld:", lineno);
			printf("%s", line);
			found++;
		}
	}
</pre>There's clearly a tradeoff:
the last version is in some sense the most clear
(and the most verbose),
but it ends up repeating the line-number printing
and any other processing which must be done for found lines.
Therefore, the compressed,
perhaps slightly more cryptic forms are better:
some day,
it's a virtual certainty that more processing will be added for printed lines
(for example,
if we're searching multiple files,
we'll want to print the filename for matching lines, too),
and if the printing is duplicated in two places,
it's far too likely that we'll overlook that fact
and add the new code in only one place.
</p><p>One last point on the pattern-matching program:
it's probably clearer to declare a pointer variable
<pre>	char *pat;
</pre>and set it to the word from <TT>argv</TT> to be used as the 
search pattern (<TT>argv[1]</TT> or <TT>*argv</TT>,
depending on whether we're looking at page 116 or 117),
and then use that in the call to <TT>strstr</TT>:
<pre>	if (strstr(line, pat) != NULL ...
</pre></p><hr>
<p>
Read sequentially:
<a href="sx8i.html" rev=precedes>prev</a>
<a href="sx9.html" rel=precedes>next</a>
<a href="sx8.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
